package web.admin.views

import ant.cps._
import dispalt.relay.gql
import japgolly.scalajs.react._
import japgolly.scalajs.react.extra.router.RouterCtl
import japgolly.scalajs.react.vdom.html_<^._
import moment.Moment
import relay.QueryRenderer.Component
import relay.components._
import relay.graphql.TaggedNode
import web.admin.cps.AdminCore
import web.admin.data.{BaseViewerFrag, FullUserFrag}
import web.admin.routes.Routes.baseViewer
import web.admin.routes.{Page, UserPage}
import web.base.all._
import web.cps.{PolicyList, Sectional}

import scala.scalajs.js
import scala.scalajs.js.Dynamic.literal

object SpecificUserView {

  @js.native
  trait BaseFullUserFrag extends BaseViewerFrag {
    val fullUser: js.UndefOr[FullUserFrag]
  }

  @gql("""
      fragment SpecificUserView_fullUser on FullUser {
        rawId
        id
        policies  {
          edges {
            node {
              quoteId
            }
          }
        }
      }
    """)
  object fullUser extends TaggedNode

  @gql("""
      fragment SpecificUserView_viewer on Viewer {
        id
        user {
          id
          user { firstName lastName }
        }
        ...AdminCore_viewer
      }
  """)
  object viewer extends TaggedNode

  def row(name: String, value: VdomNode) = {
    Row()(Col(new Col.Opt {
      override val span = 12
    })(name), Col(new Col.Opt {
      override val span = 12
    })(value))
  }

  val C = ScalaComponent
    .builder[RouterCtl[Page]]("SpecificUserView")
    .stateless
    .render { r =>
      val rb = r.relayBackend[relay.generated.UserView]
      val fu = rb.relayProps.fullUser.get
      AdminCore.Container.rprops(rb.relayProps)(AdminCore.Props(fluid = true, ctl = r.props))(
        Sectional.C(Sectional.Props(Card.Opts))(
          <.h2(s"${fu.user.firstName} ${fu.user.lastName} - ${fu.roles.mkString(", ")}", Icon("refresh")),
          row("Id", fu.rawId),
          row("Lookup Id", fu.id),
          row("First Name", fu.user.firstName),
          row("Last Name", fu.user.lastName),
          row("Email", fu.user.email),
          row("Created", Moment(fu.user.timeCreatedMs).fromNow()),
          row("Permissions", fu.permissions.mkString(", ")),
          row("Num of Policies", fu.policies.edges.length),
          row("Num of Events", fu.partyEvents.edges.length)),
        PolicyList(fu.policies.edges.map(_.node)),
        Sectional(Timeline {
          var i = 0
          fu.partyEvents.edges.toVdomArray { edge =>
            val msg = edge.node.tc
            i += 1
            Timeline.Item.C.withKey(i)(Timeline.Item.Opts)(Moment(edge.node.when).fromNow(), " - ", msg)
          }
        }))
    }
    .buildRelay[BaseFullUserFrag]

  val Container = FragmentContainer.buildRelay(C, "fullUser" -> fullUser, "viewer" -> viewer)

  // Tes
  @gql("""
    query UserView($id: ID!) @scalajs(useNulls: true) {
      viewer {
        id
        ...SpecificUserView_viewer
      }
      node(id: $id) @scalajs(extends: "Foo") {
        id
        ... on FullUser @scalajs(extends: "Foo12")  {
          id
          ...SpecificUserView_fullUser
        }
      }
    }
  """)
  object userViewQ extends js.Object

  def apply(page: UserPage, r: RouterCtl[Page]): Component.Unmounted = {
    baseViewer[BaseFullUserFrag](relay.generated.UserView, r, { rp =>
      val rsp = literal(fullUser = rp.node)
      // Foo
      Container.rprops(rp.mergeLeftType(rsp))(r)
    }, Some(new js.Object {
      val id          = page.s
      val policyFirst = 100
      val partyFirst  = 100
    }))
  }
}
